安装Nginx教程

一、yum源安装Nginx

配置Yum源的官网:nginx: Linux packages

将上述Nginx的官方yum源复制下来👆

在/etc/yum.repos.d/目录下新建 nginx.repo,将yum源信息粘贴到nginx.repo文件中👇

[root@xiaolizi ~]# vim /etc/nginx/nginx.conf
[nginx-stable]
name=nginx stable repo
baseurl=http://nginx.org/packages/centos/$releasever/$basearch/
gpgcheck=1
enabled=1
gpgkey=https://nginx.org/keys/nginx_signing.key
module_hotfixes=true

[nginx-mainline]
name=nginx mainline repo
baseurl=http://nginx.org/packages/mainline/centos/$releasever/$basearch/
gpgcheck=1
enabled=0
gpgkey=https://nginx.org/keys/nginx_signing.key
module_hotfixes=true

清理yum缓存、缓存软件包信息、查看yum源信息 👇

[root@xiaolizi ~]# yum clean all
[root@xiaolizi ~]# yum makecache fast
[root@xiaolizi ~]# yum repolist

 安装yum-utils,要用yum-config-manager 管理 [nginx-mainline] ,如仅使用 [nginx-stable] 的相关信息, 则可跳过此步

[root@xiaolizi ~]# yum install yum-utils -y
[root@xiaolizi ~]# yum-config-manager --enable nginx-mainline

yum 安装 nginx  :

[root@xiaolizi ~]# yum -y install nginx

 启动nginx :

[root@xiaolizi ~]# systemctl start nginx

用以下命令查看nginx的版本 :

[root@xiaolizi ~]# nginx -v
nginx version: nginx/1.24.0
[root@xiaolizi ~]# nginx -V
nginx version: nginx/1.24.0
built by gcc 4.8.5 20150623 (Red Hat 4.8.5-44) (GCC) 
built with OpenSSL 1.0.2k-fips  26 Jan 2017
TLS SNI support enabled
configure arguments: --prefix=/etc/nginx --sbin-path=/usr/sbin/nginx --modules-path=/usr/lib64/nginx/modules --conf-path=/etc/nginx/nginx.conf --error-log-path=/var/log/nginx/error.log --http-log-path=/var/log/nginx/access.log --pid-path=/var/run/nginx.pid --lock-path=/var/run/nginx.lock --http-client-body-temp-path=/var/cache/nginx/client_temp --http-proxy-temp-path=/var/cache/nginx/proxy_temp --http-fastcgi-temp-path=/var/cache/nginx/fastcgi_temp --http-uwsgi-temp-path=/var/cache/nginx/uwsgi_temp --http-scgi-temp-path=/var/cache/nginx/scgi_temp --user=nginx --group=nginx --with-compat --with-file-aio --with-threads --with-http_addition_module --with-http_auth_request_module --with-http_dav_module --with-http_flv_module --with-http_gunzip_module --with-http_gzip_static_module --with-http_mp4_module --with-http_random_index_module --with-http_realip_module --with-http_secure_link_module --with-http_slice_module --with-http_ssl_module --with-http_stub_status_module --with-http_sub_module --with-http_v2_module --with-mail --with-mail_ssl_module --with-stream --with-stream_realip_module --with-stream_ssl_module --with-stream_ssl_preread_module --with-cc-opt='-O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches -m64 -mtune=generic -fPIC' --with-ld-opt='-Wl,-z,relro -Wl,-z,now -pie'

 关闭防火墙和selinux :

[root@xializi ~]# setenforce 0 && sed -i '/SELINUX/s/enforcing/disabled/' /etc/selinux/config
[root@xializi ~]# systemctl stop firewalld && systemctl disable firewalld

 设置开机启动 :

[root@xiaolizi ~]# systemctl enable nginx 

查看nginx进程 :

[root@xiaolizi ~]#  ss -nplt | grep nginx
LISTEN     0      128          *:80                       *:*                   users:(("nginx",pid=71712,fd=6),("nginx",pid=71711,fd=6),("nginx",pid=59235,fd=6))

 在浏览器中输入ip地址显示下图则表示Nginx安装成功

二、源码安装Nginx

Nginx官网地址:Index of /download/ (nginx.org)

1、安装编译环境

[root@xiaolizi ~]# yum -y install gcc gcc-c++

 2、安装pcre软件包(使nginx支持http rewrite模块

[root@xiaolizi ~]# yum install -y pcre pcre-devel

3、安装openssl-devel(使nginx支持ssl)

[root@xiaolizi ~]# yum install -y openssl openssl-devel

4、安装zlib

[root@xiaolizi ~]# yum install -y zlib zlib-devel

5、创建用户nginx并设置密码

[root@xiaolizi ~]# useradd nginx 
[root@xiaolizi ~]# passwd nginx

6、安装nginx(下载、解压、预编译、make编译及安装)

[root@xiaolizi ~]# wget http://nginx.org/download/nginx-1.16.0.tar.gz
[root@xiaolizi ~]# tar xzf nginx-1.16.0.tar.gz -C /usr/local/
[root@xiaolizi ~]# cd /usr/local/nginx-1.16.0/
[root@xiaolizi nginx-1.16.0]# ./configure --prefix=/usr/local/nginx --group=nginx --user=nginx --sbin-path=/usr/local/nginx/sbin/nginx --conf-path=/etc/nginx/nginx.conf --error-log-path=/var/log/nginx/error.log --http-log-path=/var/log/nginx/access.log --http-client-body-temp-path=/tmp/nginx/client_body --http-proxy-temp-path=/tmp/nginx/proxy --http-fastcgi-temp-path=/tmp/nginx/fastcgi --pid-path=/var/run/nginx.pid --lock-path=/var/lock/nginx --with-http_stub_status_module --with-http_ssl_module --with-http_gzip_static_module --with-pcre --with-http_realip_module --with-stream
[root@xiaolizi nginx-1.16.0]# make && make install
[root@xiaolizi nginx-1.16.0]# mkdir /tmp/nginx

7、Nginx 编译参数(此步为了解编译信息,可不看此步骤)

# 查看 nginx 安装的模块
[root@localhost ~]#/usr/local/nginx/sbin/nginx -V
# 模块参数具体功能 
--with-cc-opt='-g -O2 -fPIE -fstack-protector    //设置额外的参数将被添加到CFLAGS变量。(FreeBSD或者ubuntu使用)
--param=ssp-buffer-size=4 -Wformat -Werror=format-security -D_FORTIFY_SOURCE=2' 
--with-ld-opt='-Wl,-Bsymbolic-functions -fPIE -pie -Wl,-z,relro -Wl,-z,now' 

--prefix=/usr/local/nginx                        //指向安装目录
--conf-path=/etc/nginx/nginx.conf                //指定配置文件
--http-log-path=/var/log/nginx/access.log        //指定访问日志
--error-log-path=/var/log/nginx/error.log        //指定错误日志
--lock-path=/var/lock/nginx.lock                 //指定lock文件
--pid-path=/run/nginx.pid                        //指定pid文件

--http-client-body-temp-path=/var/lib/nginx/body    //设定http客户端请求临时文件路径
--http-fastcgi-temp-path=/var/lib/nginx/fastcgi     //设定http fastcgi临时文件路径
--http-proxy-temp-path=/var/lib/nginx/proxy         //设定http代理临时文件路径
--http-scgi-temp-path=/var/lib/nginx/scgi           //设定http scgi临时文件路径
--http-uwsgi-temp-path=/var/lib/nginx/uwsgi         //设定http uwsgi临时文件路径

--with-debug                                        //启用debug日志
--with-pcre-jit                                     //编译PCRE包含“just-in-time compilation”
--with-ipv6                                         //启用ipv6支持
--with-http_ssl_module                              //启用ssl支持
--with-http_stub_status_module                      //获取nginx自上次启动以来的状态
--with-http_realip_module                 //允许从请求标头更改客户端的IP地址值,默认为关
--with-http_auth_request_module           //实现基于一个子请求的结果的客户端授权。如果该子请求返回的2xx响应代码,所述接入是允许的。如果它返回401或403中,访问被拒绝与相应的错误代码。由子请求返回的任何其他响应代码被认为是一个错误。
--with-http_addition_module               //作为一个输出过滤器,支持不完全缓冲,分部分响应请求
--with-http_dav_module                    //增加PUT,DELETE,MKCOL:创建集合,COPY和MOVE方法 默认关闭,需编译开启
--with-http_geoip_module                  //使用预编译的MaxMind数据库解析客户端IP地址,得到变量值
--with-http_gunzip_module                 //它为不支持“gzip”编码方法的客户端解压具有“Content-Encoding: gzip”头的响应。
--with-http_gzip_static_module            //在线实时压缩输出数据流
--with-http_image_filter_module           //传输JPEG/GIF/PNG 图片的一个过滤器)(默认为不启用。gd库要用到)
--with-http_spdy_module                   //SPDY可以缩短网页的加载时间
--with-http_sub_module                    //允许用一些其他文本替换nginx响应中的一些文本
--with-http_xslt_module                   //过滤转换XML请求
--with-mail                               //启用POP3/IMAP4/SMTP代理模块支持
--with-mail_ssl_module                    //启用ngx_mail_ssl_module支持启用外部模块支持

8、启动nginx服务

[root@xiaolizi ~]# /usr/local/nginx/sbin/nginx

9、实现nginx开机自启

a.创建文件并将下述信息写入文件中👇

[root@xiaolizi ~]# vim /etc/init.d/nginx
#!/bin/sh 
# 
# nginx - this script starts and stops the nginx daemon 
# 
# chkconfig:  - 85 15  
# description:  Nginx is an HTTP(S) server, HTTP(S) reverse \ 
#              proxy and IMAP/POP3 proxy server 
# processname: nginx 
# config:      /etc/nginx/nginx.conf 
# config:      /etc/sysconfig/nginx 
# pidfile:    /var/run/nginx.pid 
  
# Source function library. 
. /etc/rc.d/init.d/functions
  
# Source networking configuration. 
. /etc/sysconfig/network
  
# Check that networking is up. 
[ "$NETWORKING" = "no" ] && exit 0 
  
nginx="/usr/local/nginx/sbin/nginx"
prog=$(basename $nginx) 
  
NGINX_CONF_FILE="/etc/nginx/nginx.conf"
  
[ -f /etc/sysconfig/nginx ] && . /etc/sysconfig/nginx
  
lockfile=/var/lock/nginx
  
make_dirs() { 
  # make required directories 
  user=`nginx -V 2>&1 | grep "configure arguments:" | sed 's/[^*]*--user=\([^ ]*\).*/\1/g' -` 
  options=`$nginx -V 2>&1 | grep 'configure arguments:'` 
  for opt in $options; do
      if [ `echo $opt | grep '.*-temp-path'` ]; then
          value=`echo $opt | cut -d "=" -f 2` 
          if [ ! -d "$value" ]; then
              # echo "creating" $value 
              mkdir -p $value && chown -R $user $value 
          fi
      fi
  done
} 
  
start() { 
    [ -x $nginx ] || exit 5 
    [ -f $NGINX_CONF_FILE ] || exit 6 
    make_dirs 
    echo -n $"Starting $prog: "
    daemon $nginx -c $NGINX_CONF_FILE 
    retval=$? 
    echo
    [ $retval -eq 0 ] && touch $lockfile 
    return $retval 
} 
  
stop() { 
    echo -n $"Stopping $prog: "
    killproc $prog -QUIT 
    retval=$? 
    echo
    [ $retval -eq 0 ] && rm -f $lockfile 
    return $retval 
} 
  
restart() { 
    configtest || return $? 
    stop 
    sleep 1 
    start 
} 
  
reload() { 
    configtest || return $? 
    echo -n $"Reloading $prog: "
    killproc $nginx -HUP 
    RETVAL=$? 
    echo
} 
  
force_reload() { 
    restart 
} 
  
configtest() { 
  $nginx -t -c $NGINX_CONF_FILE 
} 
  
rh_status() { 
    status $prog 
} 
  
rh_status_q() { 
    rh_status >/dev/null 2>&1 
} 
  
case "$1" in
    start) 
        rh_status_q && exit 0 
        $1 
        ;; 
    stop) 
        rh_status_q || exit 0 
        $1 
        ;; 
    restart|configtest) 
        $1 
        ;; 
    reload) 
        rh_status_q || exit 7 
        $1 
        ;; 
    force-reload) 
        force_reload 
        ;; 
    status) 
        rh_status 
        ;; 
    condrestart|try-restart) 
        rh_status_q || exit 0 
            ;; 
    *) 
        echo $"Usage: $0 {start|stop|status|restart|condrestart|try-restart|reload|force-reload|configtest}"
        exit 2 
esac

b、添加权限

[root@xiaolizi ~]# chmod +x /etc/init.d/nginx

c、重新加载系统启动文件

[root@xiaolizi ~]# systemctl daemon-reload

d、启动并设置开机自启

[root@xiaolizi ~]# systemctl start nginx
[root@xiaolizi ~]# /sbin/chkconfig nginx on

10、在浏览器中输入ip地址显示如下图所示信息,则安装源码Nginx完成^_^

三、配置文件修改

1.使用alias实现虚拟目录 ( yum安装的nginx配置文件默认在`/etc/nginx/conf.d/default.conf `  |  源码安装的nginx配置文件默认在`/etc/nginx/nginx.conf` )

location /test {
            alias   /var/www/qianfeng/;
            index  index.html; 
        }
        
location /test {
            root   /var/www/qianfeng/;
            index  index.html; 
        }

2、通过 stub_status 模块监控 nginx 的工作状态

1)、通过 nginx  -V 命令查看是否已安装 stub_status 模块

2)、编辑 /etc/nginx/nginx.conf 配置文件

#添加以下内容~~ 
location /nginx-status { 
      stub_status on; 
      access_log    /var/log/nginx/nginxstatus.log;    #设置日志文件的位置 
      auth_basic    "nginx-status";    #指定认证机制(与location后面的内容相同即可) 
      auth_basic_user_file    /etc/nginx/htpasswd;     #指定认证的密码文件 
      }

3).创建认证口令文件并添加用户qianfeng和zdgg,密码用md5加密

[root@xiaolizi ~]# yum install -y httpd-tools 
htpasswd -c -m /etc/nginx/htpasswd xiaolizi            
htpasswd -m /etc/nginx/htpasswd xiaoli

4)、重启服务

5)、客户端访问 http://ip/nginx-status 即可(例:10.36.192.66/nginx-status)

四、常见错误总结

1、修改完配置重新加载配置时出错(yum安装的nginx)

[root@xiaolizi ~]# vim /etc/nginx/conf.d/default.conf
[root@xiaolizi ~]# nginx -s reload
nginx: [error] open() "/var/run/nginx.pid" failed (2: No such file or directory)

分析:是由于nginx服务未启动导致nginx -s reload 重新加载配置文件失败。

方法:

        a.先启动nginx之后再加载配置文件

        b.(yum安装nginx)执行 nginx -c /etc/nginx/nginx.conf 后再重载

[root@localhost nginx]# nginx -c /etc/nginx/nginx.conf 
[root@localhost nginx]# nginx -s reload

2、重新加载时出错

[linuxidc@xiaolizi ]$ nginx -s reload
nginx: [alert] could not open error log file: open() "/var/log/nginx/error.log" failed (13: Permission denied)

分析:当前用户为普通用户,对该位置没有写入权限。

方法:可以root进入服务器,重启服务器就ok了;或者让root用户为此用户提权即可

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值